VERSION 5.00
Begin VB.Form frmMain 
   Caption         =   "FPGA-USB Program"
   ClientHeight    =   8745
   ClientLeft      =   255
   ClientTop       =   330
   ClientWidth     =   10680
   LinkTopic       =   "Form1"
   ScaleHeight     =   8745
   ScaleWidth      =   10680
   Begin VB.Timer TmrMemRd 
      Enabled         =   0   'False
      Interval        =   500
      Left            =   4440
      Top             =   6000
   End
   Begin VB.CommandButton CmdDDSTune 
      Caption         =   "Send a DDS Tune"
      Height          =   375
      Left            =   2520
      TabIndex        =   31
      Top             =   3360
      Width           =   1695
   End
   Begin VB.Frame Frame2 
      Caption         =   "DRAM READ OPTIONS"
      Height          =   1455
      Left            =   7680
      TabIndex        =   27
      Top             =   4320
      Width           =   2775
      Begin VB.OptionButton RdOption2 
         Caption         =   "Read as Ascii Chars"
         Height          =   375
         Left            =   240
         TabIndex        =   29
         Top             =   600
         Width           =   2055
      End
      Begin VB.OptionButton RdOption1 
         Caption         =   "Read as Hex Numbers"
         Height          =   375
         Left            =   240
         TabIndex        =   28
         Top             =   240
         Value           =   -1  'True
         Width           =   2175
      End
   End
   Begin VB.Frame Frame1 
      Caption         =   "DRAM LOAD OPTIONS"
      Height          =   1575
      Left            =   7680
      TabIndex        =   24
      Top             =   1200
      Width           =   2775
      Begin VB.OptionButton LdOption3 
         Caption         =   "Load DDS Sine wave"
         Height          =   375
         Left            =   240
         TabIndex        =   30
         Top             =   1080
         Width           =   2415
      End
      Begin VB.OptionButton LdOption2 
         Caption         =   "Load from LoadVals.txt file"
         Height          =   375
         Left            =   240
         TabIndex        =   26
         Top             =   720
         Width           =   2175
      End
      Begin VB.OptionButton LdOption1 
         Caption         =   "Load from Program Algorithm"
         Height          =   255
         Left            =   240
         TabIndex        =   25
         Top             =   360
         Value           =   -1  'True
         Width           =   2415
      End
   End
   Begin VB.CommandButton CmdFindHID 
      Caption         =   "Try Re-Connecting"
      Height          =   375
      Left            =   360
      TabIndex        =   23
      Top             =   3960
      Width           =   1695
   End
   Begin VB.CommandButton CmdReadDRAM 
      Caption         =   "Read DRAM"
      Height          =   375
      Left            =   8280
      TabIndex        =   22
      Top             =   3840
      Width           =   1695
   End
   Begin VB.CommandButton CmdSendMode 
      Caption         =   "Send a Project Mode"
      Height          =   375
      Left            =   360
      TabIndex        =   21
      Top             =   3360
      Width           =   1695
   End
   Begin VB.CommandButton CmdReadBytes 
      Caption         =   "Read Byte Packet"
      Height          =   372
      Left            =   240
      TabIndex        =   20
      Top             =   720
      Width           =   1452
   End
   Begin VB.CommandButton CmdLoadDRAM 
      Caption         =   "Load DRAM"
      Height          =   375
      Left            =   8280
      TabIndex        =   19
      Top             =   720
      Width           =   1695
   End
   Begin VB.CommandButton cmdContinuous 
      Caption         =   "Start"
      Height          =   372
      Left            =   2520
      TabIndex        =   15
      Top             =   2640
      Width           =   1452
   End
   Begin VB.CommandButton cmdSendBytes 
      Caption         =   "Send hex Bytes"
      Height          =   372
      Left            =   240
      TabIndex        =   14
      Top             =   120
      Width           =   1452
   End
   Begin VB.TextBox Progress 
      Height          =   375
      Left            =   8400
      TabIndex        =   13
      Text            =   "Progress"
      Top             =   2880
      Width           =   1335
   End
   Begin VB.TextBox Byte1 
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   12
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   1920
      TabIndex        =   12
      Top             =   120
      Width           =   2895
   End
   Begin VB.TextBox Text 
      Alignment       =   2  'Center
      Enabled         =   0   'False
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   24
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H000000FF&
      Height          =   735
      Index           =   7
      Left            =   6000
      Locked          =   -1  'True
      TabIndex        =   10
      Text            =   "_"
      Top             =   1200
      Width           =   735
   End
   Begin VB.TextBox Text 
      Alignment       =   2  'Center
      Enabled         =   0   'False
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   24
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H000000FF&
      Height          =   735
      Index           =   6
      Left            =   5160
      Locked          =   -1  'True
      TabIndex        =   9
      Text            =   "_"
      Top             =   1200
      Width           =   735
   End
   Begin VB.TextBox Text 
      Alignment       =   2  'Center
      Enabled         =   0   'False
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   24
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H000000FF&
      Height          =   735
      Index           =   5
      Left            =   4320
      Locked          =   -1  'True
      TabIndex        =   8
      Text            =   "_"
      Top             =   1200
      Width           =   735
   End
   Begin VB.TextBox Text 
      Alignment       =   2  'Center
      Enabled         =   0   'False
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   24
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H000000FF&
      Height          =   735
      Index           =   4
      Left            =   3480
      Locked          =   -1  'True
      TabIndex        =   7
      Text            =   "_"
      Top             =   1200
      Width           =   735
   End
   Begin VB.TextBox Text 
      Alignment       =   2  'Center
      Enabled         =   0   'False
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   24
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H000000FF&
      Height          =   735
      Index           =   1
      Left            =   960
      Locked          =   -1  'True
      TabIndex        =   4
      Text            =   "_"
      Top             =   1200
      Width           =   735
   End
   Begin VB.TextBox Text 
      Alignment       =   2  'Center
      Enabled         =   0   'False
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   24
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H000000FF&
      Height          =   735
      Index           =   2
      Left            =   1800
      Locked          =   -1  'True
      TabIndex        =   3
      Text            =   "_"
      Top             =   1200
      Width           =   735
   End
   Begin VB.TextBox Text 
      Alignment       =   2  'Center
      Enabled         =   0   'False
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   24
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H000000FF&
      Height          =   735
      Index           =   3
      Left            =   2640
      Locked          =   -1  'True
      TabIndex        =   2
      Text            =   "_"
      Top             =   1200
      Width           =   735
   End
   Begin VB.TextBox Text 
      Alignment       =   2  'Center
      Enabled         =   0   'False
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   24
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H000000FF&
      Height          =   735
      Index           =   0
      Left            =   120
      Locked          =   -1  'True
      TabIndex        =   1
      Text            =   "_"
      Top             =   1200
      Width           =   735
   End
   Begin VB.Timer TmrDataCollect 
      Left            =   2040
      Top             =   7320
   End
   Begin VB.Timer TmrDelay 
      Left            =   4440
      Top             =   7320
   End
   Begin VB.ListBox DebugOut 
      Height          =   2985
      ItemData        =   "frmMain.frx":0000
      Left            =   240
      List            =   "frmMain.frx":0002
      TabIndex        =   0
      Top             =   5400
      Width           =   6615
   End
   Begin VB.Label Label7 
      Caption         =   "Mem operations require state machine in FPGA to handle data."
      Height          =   495
      Left            =   7680
      TabIndex        =   33
      Top             =   120
      Width           =   2895
   End
   Begin VB.Label LabelLocs 
      Height          =   375
      Left            =   7680
      TabIndex        =   32
      Top             =   3360
      Width           =   2655
   End
   Begin VB.Label Label6 
      Alignment       =   2  'Center
      Caption         =   "Debug Window"
      Height          =   255
      Left            =   1320
      TabIndex        =   18
      Top             =   5040
      Width           =   2175
   End
   Begin VB.Label Label5 
      Alignment       =   2  'Center
      Caption         =   "Hex Bytes Received"
      Height          =   255
      Left            =   2520
      TabIndex        =   17
      Top             =   840
      Width           =   1455
   End
   Begin VB.Label Label4 
      Alignment       =   2  'Center
      Caption         =   "Receive Continuous Packets"
      Height          =   255
      Left            =   240
      TabIndex        =   16
      Top             =   2640
      Width           =   2295
   End
   Begin VB.Label Label1 
      Caption         =   "       D5              D6              D7              D8"
      Height          =   255
      Left            =   3480
      TabIndex        =   11
      Top             =   2040
      Width           =   3255
   End
   Begin VB.Label Label3 
      Alignment       =   2  'Center
      Caption         =   "Sampling FPGA hex data at 5 hz "
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   9.75
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H000000C0&
      Height          =   375
      Left            =   960
      TabIndex        =   6
      Top             =   2280
      Width           =   3975
   End
   Begin VB.Label Label2 
      Caption         =   "       D1              D2              D3              D4"
      Height          =   255
      Left            =   120
      TabIndex        =   5
      Top             =   2040
      Width           =   3255
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
'**********************************************
' Johns Hopkins University ECE Dept.
' This program and its companion VHDL codes may be
'  used freely and modified as long as this header is retained.
' This program is based on Visual Basic usbhidio, Version 2, by
'  Jan Axelson, Lakeview Research, http://www.lvr.com.
' Any page references are to "USB Complete", 3rd Edition, by Jan Axelson
'***********************************************
'The program provides USB IO between a host PC and an
'  XESS XSA board FPGA using the xstend boards with the Hopkins USB interface.
'All data transfers take place directly through D+/D- connections to the FPGA pins,
'  via the XST header.
'The companion FPGA interface is USBF_INTF.vhd, using package USBF_Declares.vhd

'***********************************************
'This application has been tested on Windows XP and Vista Premium.

'Dim ReadBuffer() As Byte 'These are made public in code Module1
'Dim SendBuffer() As Byte

'These values are set in the FPGA enumeration data.
Const FPGAVendorID = &H925    '0925h is Lakeview Research's vendor ID.
Const FPGAProductID = &H1234  'FPGA product ID
'Version Number = 554 is for the USB interface driving the D+/D- lines
'UsagePage = "FFB2" is for the XSA3S1000 board

'===================================================================================
Function FindTheHid() As Boolean
'This long and tortuous function (what would we do without Mr. Axelson?)
'  makes a series of API calls to locate the desired HID-class FPGA device.
'Returns True if an FPGA device is detected, False if not detected.
Dim Count As Integer
Dim GUIDString As String, manuf
Dim HidGuid As GUID
Dim MemberIndex As Long

LastDevice = False
MyDeviceDetected = False
DeviceInfoSet = 0
DeviceAttributes.VendorID = 0   'zero out any left over ID info
DeviceAttributes.ProductID = 0
DeviceAttributes.VersionNumber = 0
DebugOut.AddItem "**** Searching for the FPGA HID *****"

'Values for SECURITY_ATTRIBUTES structure:
Security.lpSecurityDescriptor = 0
Security.bInheritHandle = True
Security.nLength = Len(Security)

'******************************************************************
'HidD_GetHidGuid
'Get the GUID for all system HIDs.
'Returns: the GUID in HidGuid.
'The routine doesn't return a value in Result but the routine
'is declared as a function for consistency with the other API calls.
'******************************************************************
result = HidD_GetHidGuid(HidGuid)
Call DisplayResultOfAPICall("GetHidGuid")

'Display the GUID.
GUIDString = _
    Hex$(HidGuid.Data1) & "-" & _
    Hex$(HidGuid.Data2) & "-" & _
    Hex$(HidGuid.Data3) & "-"

For Count = 0 To 7
    'Ensure that each of the 8 bytes in the GUID displays two characters.
    If HidGuid.Data4(Count) >= &H10 Then
        GUIDString = GUIDString & Hex$(HidGuid.Data4(Count)) & " "
    Else
        GUIDString = GUIDString & "0" & Hex$(HidGuid.Data4(Count)) & " "
    End If
Next Count
' DebugOut.AddItem "  GUID for system HIDs: " & GUIDString

'*****************************************************************
'API SetupDiGetClassDevs
'Returns: handle to a device information set for all installed devices.
'Requires: the HidGuid returned in GetHidGuid.
'*****************************************************************
DeviceInfoSet = SetupDiGetClassDevs _
    (HidGuid, _
    vbNullString, _
    0, _
    (DIGCF_PRESENT Or DIGCF_DEVICEINTERFACE))
' Call DisplayResultOfAPICall("SetupDiClassDevs")
DataString = GetDataString(DeviceInfoSet, 32)

'**********************************************************
'SetupDiEnumDeviceInterfaces
'On return, MyDeviceInterfaceData contains the handle to a
'SP_DEVICE_INTERFACE_DATA structure for a detected device.
'Requires:
'1. The DeviceInfoSet returned in SetupDiGetClassDevs.
'2. The HidGuid returned in GetHidGuid.
'3. An index to specify a device.
'**********************************************************

'Begin with 0 and increment until no more devices are detected.
MemberIndex = 0
Do
    'The cbSize element of the MyDeviceInterfaceData structure must be set to
    'the structure's size in bytes. The size is 28 bytes.
    MyDeviceInterfaceData.cbSize = LenB(MyDeviceInterfaceData)
    result = SetupDiEnumDeviceInterfaces _
        (DeviceInfoSet, _
        0, _
        HidGuid, _
        MemberIndex, _
        MyDeviceInterfaceData)
    
    ' Call DisplayResultOfAPICall("SetupDiEnumDeviceInterfaces")
    If result = 0 Then
        LastDevice = True
        GoTo CONTINUE
    End If
    
    'A device exists, display the information returned.
    '    DebugOut.AddItem "  DeviceInfoSet for device #" & CStr(MemberIndex) & ": "
    '    DebugOut.AddItem "  cbSize = " & CStr(MyDeviceInterfaceData.cbSize)
    '    DebugOut.AddItem _
    '        "  InterfaceClassGuid.Data1 = " & Hex$(MyDeviceInterfaceData.InterfaceClassGuid.Data1)
    '    DebugOut.AddItem _
    '        "  InterfaceClassGuid.Data2 = " & Hex$(MyDeviceInterfaceData.InterfaceClassGuid.Data2)
    '    DebugOut.AddItem _
    '        "  InterfaceClassGuid.Data3 = " & Hex$(MyDeviceInterfaceData.InterfaceClassGuid.Data3)
    '    DebugOut.AddItem _
    '        "  Flags = " & Hex$(MyDeviceInterfaceData.Flags)
    
        '************************************************************************
        'SetupDiGetDeviceInterfaceDetail
        'Returns: an SP_DEVICE_INTERFACE_DETAIL_DATA structure
        'containing information about a device.
        'To retrieve the information, call this function twice.
        'The first time returns the size of the structure in Needed.
        'The second time returns a pointer to the data in DeviceInfoSet.
        'Requires:
        'A DeviceInfoSet returned by SetupDiGetClassDevs and
        'an SP_DEVICE_INTERFACE_DATA structure returned by SetupDiEnumDeviceInterfaces.
        '************************************************************************
        MyDeviceInfoData.cbSize = Len(MyDeviceInfoData)
        result = SetupDiGetDeviceInterfaceDetail _
           (DeviceInfoSet, _
           MyDeviceInterfaceData, _
           0, _
           0, _
           Needed, _
           0)
        DetailData = Needed
            
        'Call DisplayResultOfAPICall("SetupDiGetDeviceInterfaceDetail")
        'DebugOut.AddItem "  Required buffer size for the data: " & Needed
        
        'Store the structure's size.
        MyDeviceInterfaceDetailData.cbSize = _
            Len(MyDeviceInterfaceDetailData)
        
        'Allocate a byte array for MyDeviceInterfaceDetailData structure
        ReDim DetailDataBuffer(Needed)
        'Store cbSize in the first four bytes of the array.
        Call RtlMoveMemory _
            (DetailDataBuffer(0), _
            MyDeviceInterfaceDetailData, _
            4)
            
        'Call SetupDiGetDeviceInterfaceDetail again.
        'This time, pass the address of the first element of DetailDataBuffer
        'and the returned required buffer size in DetailData.
        result = SetupDiGetDeviceInterfaceDetail _
           (DeviceInfoSet, _
           MyDeviceInterfaceData, _
           VarPtr(DetailDataBuffer(0)), _
           DetailData, _
           Needed, _
           0)
        
        'Call DisplayResultOfAPICall(" Result of second call: ")
        'DebugOut.AddItem "  MyDeviceInterfaceDetailData.cbSize: " & _
            CStr(MyDeviceInterfaceDetailData.cbSize)
        
        'Convert the byte array to a string.
        DevicePathName = CStr(DetailDataBuffer())
        'Convert to Unicode.
        DevicePathName = StrConv(DevicePathName, vbUnicode)
        'Strip cbSize (4 bytes) from the beginning.
        DevicePathName = Right$(DevicePathName, Len(DevicePathName) - 4)
         DebugOut.AddItem "  Device pathname: " & DevicePathName

                
        '**********************************************************
        'CreateFile
        'Returns: handle that enables reading and writing to the device.
        'Requires:
        'The DevicePathName returned by SetupDiGetDeviceInterfaceDetail.
        '**********************************************************
        HIDHandle = CreateFile _
            (DevicePathName, _
            GENERIC_READ Or GENERIC_WRITE, _
            (FILE_SHARE_READ Or FILE_SHARE_WRITE), _
            Security, _
            OPEN_EXISTING, _
            0&, _
            0)
            
        Call DisplayResultOfAPICall("CreateFile")
        DebugOut.AddItem "  Returned handle: " & HIDHandle  'Hex$(HIDHandle) & "h"
        
        'Now we can find out if it's the device we're looking for.
        
        '*********************************************************
        'HidD_GetAttributes
        'Requests information from the device.
        'Requires: The handle returned by CreateFile.
        'Returns: an HIDD_ATTRIBUTES structure containing
        'the Vendor ID, Product ID, and Product Version Number.
        'Use this information to determine if the detected device
        'is the one we're looking for.
        '*********************************************************
        'Set the Size property to the number of bytes in the structure.
        DeviceAttributes.Size = LenB(DeviceAttributes)
        result = HidD_GetAttributes(HIDHandle, DeviceAttributes)
            
        Call DisplayResultOfAPICall("HidD_GetAttributes")
        'If Result <> 0 Then
        '    DebugOut.AddItem "  HIDD_ATTRIBUTES structure filled without error."
        'Else
        '    DebugOut.AddItem "  Error in filling HIDD_ATTRIBUTES structure."
        'End If
    
        'DebugOut.AddItem "  Structure size: " & DeviceAttributes.Size
        DebugOut.AddItem "  Vendor ID: " & Hex$(DeviceAttributes.VendorID)
        DebugOut.AddItem "  Product ID: " & Hex$(DeviceAttributes.ProductID)
        DebugOut.AddItem "  Version Number: " & Hex$(DeviceAttributes.VersionNumber)
        
        'Finally! Find out if the device matches the one we're looking for.
        If (DeviceAttributes.VendorID = FPGAVendorID) And _
            (DeviceAttributes.ProductID = FPGAProductID) Then
        'Yea! It's an FPGA device.
            DebugOut.AddItem "******** FPGA DEVICE DETECTED *********"
            FPGAHandle = HIDHandle  'Store handle in a public var. for use in other modules
            MyDeviceDetected = True
        Else
            MyDeviceDetected = False
            'If it's not the one we want, close its handle.
            result = CloseHandle(HIDHandle)
            'DisplayResultOfAPICall ("CloseHandle")
        End If
    'End If
CONTINUE:  'Keep looking until we find the device or there are no more left to examine.
    MemberIndex = MemberIndex + 1
Loop Until (LastDevice = True) Or (MyDeviceDetected = True)

'Free the memory reserved for the DeviceInfoSet returned by SetupDiGetClassDevs.
result = SetupDiDestroyDeviceInfoList _
    (DeviceInfoSet)
'Call DisplayResultOfAPICall("DestroyDeviceInfoList")

If MyDeviceDetected = True Then
    FindTheHid = True
    'Learn the capabilities of the device
    Call GetDeviceCapabilities
    '***Here's where we would get another handle for an overlapped ReadFiles.
     
    'Allocate static SendBuffer and ReadBuffer based on buffer size in capabilities.
    'These arrays begin at 0, so subtract 1 from number of bytes when redim'ing.
    ReDim SendBuffer(Capabilities.OutputReportByteLength - 1)
    SendBuffer(0) = 0       'report id always stays zero
    ReDim ReadBuffer(Capabilities.InputReportByteLength - 1)
    ReadBuffer(0) = 0       'report id always stays zero
    
    If Hex(Capabilities.UsagePage) = "FFB2" Then
        DebugOut.AddItem "Usage FFB2 - Seems we are talking to an XSA3S1000 board."
    End If
    'The following only applies if EP1 configured for interrupt reads.
    result = HidD_SetNumInputBuffers(HIDHandle, 500) 'Inbuf only used for interrupt xfers
    If result = 0 Then DebugOut.AddItem "SetNumBuffers failed"
    result = HidD_GetNumInputBuffers(HIDHandle, NumInBufs)
    DebugOut.AddItem "Number of input buffer set at " & NumInBufs
    'If EP1 configured, the idle rate will be set to 0 by the hub. See pg 401

    'result = HidD_GetManufacturerString(HIDHandle, manuf) '**crashes program. TBD
    'DebugOut.AddItem  manuf
    
    DebugOut.AddItem "*********** READY FOR READ/WRITE OPS **********"
    DebugOut.AddItem "  "
    
Else
    DebugOut.AddItem "******** DEVICE NOT FOUND. *********************"
    MsgBox "Failed to connect." & vbCrLf & "Reset the FPGA, and try re-connecting."
    'Allocate a default SendBuffer and ReadBuffer to avoid hangup if buffer referenced.
    'These arrays begin at 0, so subtract 1 from number of bytes when redim'ing.
    ReDim SendBuffer(9)
    SendBuffer(0) = 0       'report id always stays zero
    ReDim ReadBuffer(9)
    ReadBuffer(0) = 0       'report id always stays zero
End If
'Scroll to the bottom of the debug list box.
DebugOut.ListIndex = DebugOut.ListCount - 1

End Function 'end of function FindTheHID().
'===================================================================================

Private Function GetDataString(Address As Long, Bytes As Long) As String
'Retrieves a string of length Bytes from memory, beginning at Address.
'Adapted from Dan Appleman's "Win32 API Puzzle Book"

Dim Offset As Integer
Dim result$
Dim ThisByte As Byte

For Offset = 0 To Bytes - 1
    Call RtlMoveMemory(ByVal VarPtr(ThisByte), ByVal Address + Offset, 1)
    If (ThisByte And &HF0) = 0 Then
        result$ = result$ & "0"
    End If
    result$ = result$ & Hex$(ThisByte) & " "
Next Offset

GetDataString = result$
End Function
'===================================================================================

Private Function GetErrorString(ByVal LastError As Long) As String
'Returns the error message for the last error.
'Adapted from Dan Appleman's "Win32 API Puzzle Book"

Dim Bytes As Long
Dim ErrorString As String
ErrorString = String$(129, 0)
Bytes = FormatMessage _
    (FORMAT_MESSAGE_FROM_SYSTEM, _
    0&, _
    LastError, _
    0, _
    ErrorString$, _
    128, _
    0)
    
'Subtract two characters from the message to strip the CR and LF.
If Bytes > 2 Then
    GetErrorString = Left$(ErrorString, Bytes - 2)
End If

End Function
'===============================================================================

Private Sub Byte1_KeyUp(KeyCode As Integer, Shift As Integer)
'Interrupt when user hits a key in the Byte1 listbox, looking for a <CR>
'This let's the user just hit a <CR> to write the packet.
If MyDeviceDetected = False Then Call Comm_err: Exit Sub
If KeyCode = 13 Then Call WriteOnePacket 'send the listbox entries to the FPGA
End Sub

'====Command Button Service Subroutines=========================================
Private Sub cmdContinuous_Click()
'Turn on/off timer continuous packet transfers from the FPGA for display.
If MyDeviceDetected = False Then Call Comm_err: Exit Sub

If cmdContinuous.Caption = "Start" Then
    'Change the command button label to "Stop" continuous data
    cmdContinuous.Caption = "Stop"
    Label3.Caption = "Sampling FPGA hex data at 5 hz" 'Turn on the caption
    'Enable the timer to read the FPGA packets at 10/second.
    TmrDataCollect.Enabled = True
    pktct = 0   'reset the displayed pkt failure count
    DebugOut.RemoveItem (DebugOut.ListCount - 1) 'Rewrite last line in list box.
    DebugOut.AddItem "*** Read Packet Errors= " & pktct
    DebugOut.ListIndex = DebugOut.ListCount - 1
    
Else
    'Change the command button label back to "Start"
    cmdContinuous.Caption = "Start"
    Label3.Caption = " "    'Turn off the caption
    'Disable the timer .
    TmrDataCollect.Enabled = False
End If
 
End Sub

Private Sub CmdDDSTune_Click()
'Send a sequence of DDS control values to project in SendBuffer(2),
'  with DDS on-off control in SendBuffer(1)
If MyDeviceDetected = False Then Call Comm_err: Exit Sub

Module1.SendTones (2)
Module1.SendTones (3)
Module1.SendSweep
End Sub

Private Sub CmdFindHID_Click()
'We presume the old handles are cancelled
If MyDeviceDetected = True Then
    DebugOut.AddItem "Current connection seems OK, but we'll cancel the handle"
    DebugOut.ListIndex = DebugOut.ListCount - 1 'Scroll to the bottom of list box.
    'Exit Sub
End If
'cancel any current operation and handle and try reconnecting to FPGA
DebugOut.AddItem "Attempting to reconnect to FPGA device"
'*******************************************
'CancelIo:
'Cancels ReadFile call
'Requires the device handle.
'Returns non-zero on success.
'*******************************************
result = CancelIo(HIDHandle)
Call DisplayResultOfAPICall("CancelIo")
'A timeout may have been because the device was removed, so close open handles and
'set MyDeviceDetected=False to cause the application to look for the device again.
CloseHandle (HIDHandle)
Call DisplayResultOfAPICall("CloseHandle (HIDHandle)")
'Result = CancelIo (ReadHandle)
'CloseHandle (ReadHandle)
'Call DisplayResultOfAPICall("CloseHandle (ReadHandle)")

Err_flag = 0   're-set the global error flag
DebugOut.ListIndex = DebugOut.ListCount - 1 'Scroll to the bottom of  list box.

MyDeviceDetected = False
MyDeviceDetected = FindTheHid  'Try again after resetting the project.
End Sub

Private Sub CmdLoadDRAM_Click()
'Load the memory under program control
If MyDeviceDetected = False Then Call Comm_err: Exit Sub
pktct = 0   'reset the pkt failure count
Call Module1.Load_MemUSB
End Sub

Private Sub CmdReadBytes_Click()    'read a single pkt and display the bytes read
'We presume here that the USB interface has the PCInput array tied to signals in
'  the FPGA project so that any time we do a read we get a state of those signals.
'In a loopback mode we can just tie PCInput to PCOutput to read back what we sent.
Dim Count As Long, ByteValue As String

If MyDeviceDetected = False Then Call Comm_err: Exit Sub

Call ReadReport(1)   'get a single report from device and display bytes
If Err_flag = 1 Then
    Exit Sub
End If
'---------------------------
'Display any results in the read buffer
Label5.Caption = "Hex Bytes Read: "
For Count = 1 To UBound(ReadBuffer)
    'Add a leading 0 to single digit values 0 - F.
    If Len(Hex$(ReadBuffer(Count))) < 2 Then
        ByteValue = "0" & Hex$(ReadBuffer(Count))
    Else
        ByteValue = Hex$(ReadBuffer(Count))
    End If
    If Count < 9 Then Text(Count - 1).Text = ByteValue 'put bytes in the big text boxes
Next Count

End Sub

Private Sub CmdReadDRAM_Click()
If MyDeviceDetected = False Then Call Comm_err: Exit Sub
pktct = 0   'reset the pkt failure count
Call Module1.Read_MemUSB
End Sub

Private Sub cmdSendBytes_Click()
If MyDeviceDetected = False Then Call Comm_err: Exit Sub

Call WriteOnePacket
End Sub
'==================================================================================

Private Sub CmdSendMode_Click()
'Send a set_feature report to set the FPGA operating mode. (see Axelson, pg 403)
'We use the SendBuffer as the report buffer for this call
Dim mode As String

If MyDeviceDetected = False Then Call Comm_err: Exit Sub

mode = InputBox("Enter a hex project mode byte. " & vbLf & _
  "The project mode can be used to control FPGA operation as the designer sees fit." _
  & vbCrLf & "The received mode is an output of the FPGA USB interface.", _
        "Sending a Feature Report to Set FPGA Mode")

SendBuffer(1) = Val("&H" & mode)

result = HidD_SetFeature _
   (HIDHandle, _
    SendBuffer(0), _
    CLng(Capabilities.FeatureReportByteLength))

If result = 0 Then Call DisplayResultOfAPICall("HidD_SetFeature"): Call Comm_err
End Sub     ' Exit CmdSendMode()
'=============================================================================

Public Sub Comm_err()  ''communications error.
'Error in read or write reports or no connection established.
'Alert user to reset project, and try to enumerate for a new handle.
MsgBox "Uh oh! Communications Failed." & vbCrLf & _
        " May have lost connection to the FPGA." & vbCrLf & _
        "Try resetting the FPGA and reconnecting the usb cable." & vbCrLf & _
        "Then try the reconnect button."
DebugOut.AddItem "***Communication Failed - ***"
'*******************************************
'CancelIo:
'Cancels ReadFile call
'Requires the device handle.
'Returns non-zero on success.
'*******************************************
result = CancelIo(HIDHandle)
Call DisplayResultOfAPICall("CancelIo")
'A timeout may have occured because the device was removed, so close open handles and
'set MyDeviceDetected=False to cause the application to look for the device again.
result = CloseHandle(HIDHandle)
Call DisplayResultOfAPICall("CloseHandle (HIDHandle)")
result = CancelIo(ReadHandle)
Call DisplayResultOfAPICall("CloseHandle (ReadHandle)")

Err_flag = 1   'set the global error flag to halt any ongoing  operation.
MyDeviceDetected = False
DebugOut.ListIndex = DebugOut.ListCount - 1 'Scroll to the bottom of debug window.
    
End Sub ' End sub Comm_err()
'=============================================================================

Public Sub DisplayResultOfAPICall(FunctionName As String)
'Display the results of an API call.
Dim ErrorString As String
'DebugOut.AddItem ""
ErrorString = GetErrorString(Err.LastDllError)
DebugOut.AddItem FunctionName & "  Result = " & ErrorString
'Scroll to the bottom of the list box.
DebugOut.ListIndex = DebugOut.ListCount - 1

End Sub
'==============================================================================

Private Sub Form_Load()
frmMain.Show
'disable the 10hz timer
TmrDataCollect.Enabled = False
Label3.Caption = " "    'Turn off the continuous sampling message
Call Startup
End Sub
'=============================================================================

Private Sub Form_Unload(Cancel As Integer)
Call Shutdown
End Sub
'==============================================================================

Private Sub GetDeviceCapabilities()
'**********************************************************************
'HidD_GetPreparsedData
'Returns: a pointer to a buffer containing information about the device's capabilities.
'Requires: A handle returned by CreateFile.
'There's no need to access the buffer directly,
'but HidP_GetCaps and other API functions require a pointer to the buffer.
'**********************************************************************
Dim ppData(29) As Byte
Dim ppDataString As Variant

'Preparsed Data is a pointer to a routine-allocated buffer.
result = HidD_GetPreparsedData(HIDHandle, PreparsedData)
'Call DisplayResultOfAPICall("HidD_GetPreparsedData")

'Copy the data at PreparsedData into a byte array.
result = RtlMoveMemory _
    (ppData(0), PreparsedData, 30)
'Call DisplayResultOfAPICall("RtlMoveMemory")

ppDataString = ppData()
'Convert the data to Unicode.
ppDataString = StrConv(ppDataString, vbUnicode)

'*********************************************************************
'HidP_GetCaps - Find out the device's capabilities.
'For standard devices such as joysticks, you can find out specific capabilities.
'For a custom device like the FPGA, we know what the device capables are.
'So this call just verifies the information.
'Requires: The pointer to a buffer containing the information.
'          The pointer is returned by HidD_GetPreparsedData.
'Returns: a Capabilites structure containing the information.
'*********************************************************************
result = HidP_GetCaps(PreparsedData, Capabilities)
'Call DisplayResultOfAPICall("HidP_GetCaps")

'DebugOut.AddItem "  Last error: " & ErrorString
DebugOut.AddItem "  Usage: " & Hex$(Capabilities.Usage)
DebugOut.AddItem "  Usage Page: " & Hex$(Capabilities.UsagePage)
DebugOut.AddItem "  Input Report Byte Length: " & Capabilities.InputReportByteLength
DebugOut.AddItem "  Output Report Byte Length: " & Capabilities.OutputReportByteLength
DebugOut.AddItem "  Feature Report Byte Length: " & Capabilities.FeatureReportByteLength

'result = HidD_GetManufacturerString(HIDHandle, Manuf)
'Call DisplayResultOfAPICall("HidP_GetManufacturerString")
'DebugOut.AddItem "  Manufacturer String: " & Manuf

'Free the buffer reserved by HidD_GetPreparsedData
result = HidD_FreePreparsedData _
    (PreparsedData)
Call DisplayResultOfAPICall("HidD_FreePreparsedData")

End Sub   'End of GetDeviceCapabilities()
'==============================================================================

Public Sub ReadReport(method As Integer)
'Read one data pkt from the device using one of 3 possible methods.
'1 = GetInputReport (EP0 ctl), 2 = GetFeature (EP0 ctl), 3 = ReadFile (intrpt on EP1)
'3 can only be used if fpga is configured with EP1.
Dim Count
Dim NumberOfBytesRead As Long
Dim ByteValue As String, Read As String

GETPKT:
Err_flag = 0    're-set the public pkt-error flag for the next read
If method = 1 Then
'**************************************************
'API function: HidD_GetInputReport or HidD_GetFeature
'Read an Input report from device using a control transfer.
'Supported under Windows XP and later only.
'Needs: 1. A handle to a HID
'       2. A pointer to a buffer containing the report ID and report
'       3. The size of the buffer.
'Returns boolean: true on success, false on failure
'**************************************************
result = HidD_GetInputReport _
        (HIDHandle, _
        ReadBuffer(0), _
        CLng(Capabilities.InputReportByteLength))
'-----------------------------------------

ElseIf method = 2 Then
'Get data via EP0 feature report. This is only here to test it for future usage.
result = HidD_GetFeature _
    (HIDHandle, _
    ReadBuffer(0), _
    CLng(Capabilities.FeatureReportByteLength))
'---------------------------------------

ElseIf method = 3 Then  'This method requires EP1 to be configured in the device.
'**************************************************
'ReadFile - read report via interrupt on EP1
'Returns: the report in ReadBuffer.
'Requires: 1. a device handle returned by CreateFile
'(for overlapped I/O, CreateFile must be called with FILE_FLAG_OVERLAPPED),
'2. the Input report length in bytes returned by HidP_GetCaps,
'3. an overlapped structure whose hEvent member is set to an event object.
'*************************************************
'With overlapped ReadFile, the function returns immediately, even if the data
'  hasn't been received yet. Without this, it hangs on a read error. To be added.
result = ReadFile _
    (HIDHandle, _
    ReadBuffer(0), _
    CLng(Capabilities.InputReportByteLength), _
    NumberOfBytesRead, _
    HIDOverlapped)

End If
'--------------------------------------------
If result = 0 Then  'oops. Result = false -> read failed
        'Call DisplayResultOfAPICall("HidD_GetInputReport")
        'Call DisplayResultOfAPICall("HidD_GetFeature")
        'Call DisplayResultOfAPICall("ReadFile")
        'DebugOut.AddItem " "
    Err_flag = 1      'flag the error to notify the calling routine in case it cares
    pktct = pktct + 1   'count the pkt errors for display
    DebugOut.RemoveItem (DebugOut.ListCount - 1) 'Rewrite last line in list box.
    DebugOut.AddItem "***Read-Packet Errors= " & pktct & ",    " & IMem
    DebugOut.ListIndex = DebugOut.ListCount - 1
End If
DoEvents
End Sub     ' Exit ReadReport()
'===================================================================


'==================================================================

Public Sub SendReport()     'see Axelson, pg 335, 379
'Send a data packet to the device out of the static SendBuffer,
'  using a control transfer on EP0_OUT. This only works for XP or later.
'Alternative is to use the WriteFile API call which defaults to a ctl xfer if no EP1.
'We assume buffer is loaded before this call, and SendBuffer(0)= 0 is the report ID.
SendBuffer(0) = 0
SEND:
Err_flag = 0
result = HidD_SetOutputReport _
    (HIDHandle, _
    SendBuffer(0), _
    CLng(Capabilities.OutputReportByteLength))
    
If result = 0 Then  'oops. Something wrong. This never, or very rarely, happens.
    'Call DisplayResultOfAPICall("HidD_SetOutputReport")
    pktct = pktct + 1
    DebugOut.RemoveItem (DebugOut.ListCount - 1) 'Rewrite last line in list box.
    DebugOut.AddItem "***Write Packet Errors= " & pktct
    DebugOut.ListIndex = DebugOut.ListCount - 1
    'Err_flag = 1    'set the global pkt error flag in case the calling program cares.
End If

End Sub     ' Exit SendReport()
'==========================================================================

Private Sub Shutdown()
'Actions that must execute when the program ends.

'Close the open handles to the device.
result = CloseHandle(HIDHandle)
Call DisplayResultOfAPICall("CloseHandle (HIDHandle)")

'Result = CloseHandle (ReadHandle)
'Call DisplayResultOfAPICall("CloseHandle (ReadHandle)")

End Sub
'==============================================================================

Private Sub Startup()
'Set up the timers
TmrDelay.Enabled = False
TmrDelay.Interval = 100     '100 millisec period. This get overwritten by Delay()
TmrDataCollect.Enabled = False
TmrDataCollect.Interval = 200     '200 millisec period = 5 samples per sec
TmrMemRd.Enabled = False
TmrMemRd.Interval = 500     '500 millisec period for 64 packet burst.

'Write a Debug Report Header
DebugOut.AddItem ""
DebugOut.AddItem "******* HID Debug Report ********"
DebugOut.AddItem Format(Now, "general date")
'initialize the Byte1 write text box
Byte1.Text = "0 0 0 0 0 0 0 0"
Err_flag = 0    'reset the global error flag

If FindTheHid = False Then
    MsgBox "FPGA not detected. Check cable and FPGA configuration indicator."
    Exit Sub
End If
End Sub

'=====Timer Action Subs=============================================
Private Sub TmrDataCollect_Timer()
'Continuously read data from the device at the timer rate.
Dim Count As Long, ByteValue As String

READUSB:
Call ReadReport(1)  'Read a control report from the device every timer tick.
'---------------------
If pktct < 1000 Then      'give up the ghost if too many read errors
    Call SendReport '**this helps pkt error problem but still dont know why.
    'GoTo READUSB
Else:   'Shut down the operation
    cmdContinuous.Caption = "Start" 'Change the cmd button label back to "Start"
    Label3.Caption = "Halted - excessive packet errors " 'Turn off the red caption
    TmrDataCollect.Enabled = False 'Disable the timer.
    DebugOut.AddItem "We must have lost communications. Try an FPGA reset/reconnect."
    DebugOut.ListIndex = DebugOut.ListCount - 1
    Exit Sub
End If
'---------------------
 'If successful, display what's in the read buffer
 Label5.Caption = "Hex Bytes Read: "
 For Count = 1 To UBound(ReadBuffer)
    'Add a leading 0 to single digit values 0 - F.
    If Len(Hex$(ReadBuffer(Count))) < 2 Then
        ByteValue = "0" & Hex$(ReadBuffer(Count))
    Else
        ByteValue = Hex$(ReadBuffer(Count))
    End If
    If Count < 9 Then Text(Count - 1).Text = ByteValue 'put bytes in the big text boxes
 Next Count

End Sub


Private Sub TmrDelay_Timer()
'We want this timer interrupt to occur just once after it is enabled to create a delay.
' See function Module1.Delay(dt), which enables this timer and waits for the done flag.
TmrDelay.Enabled = False 'disable itself after the interrupt.
delay_done = 1 'indicate delay occured

End Sub

'*********************************************************************
Public Sub TmrMemRd_Timer()   'Modified LoadMem code for testing. Not used now.
'Read XSA DRAM with fpga state machine and write hex values or ascii values to
' C:/MemVals.txt, then open Notepad to view.(good font setting is Courier New-bold-11)
'FPGA returned packets have 4 16-bit values from consecutive dram locations.
Dim K As Long, P As Long, J As Long, MDat As Long, hvalue As String

'On Error GoTo ErrT
pktct = 0
P = 0   'keep track of pkts read this interrupt
NEXT_IMEM:
If 0 = (IMem Mod 4) Then ''----Read next packet from FPGA------------
    If P = 64 Then
        Exit Sub  'end this burst
    End If
    K = 0
    P = P + 1   'P is the number of pkts read so far
READUSB:
    Call frmMain.ReadReport(1)  'read next packet via control xfer.
    'Call frmMain.ReadReport(3)  'read next packet via interrupt xfer.
    If Err_flag = 1 Then        'read packet error - try re-reading
        If pktct < 20 Then      'give up the ghost if too many
            'Exit Sub
            GoTo READUSB
        Else:
            'frmMain.TmrMemRd.Interval = 5000
            TmrMemRd.Enabled = False
            'MsgBox "Halting - excessive packet errors. IMem=" & IMem
            GoTo XIT1
        End If
    End If
    DoEvents
End If
''---------------------------
'Work through the read buffer in pairs for 16-bit values
If frmMain.RdOption2.Value = False Then GoTo HEXNUMS  'interpret as 16-bit hex nums=====>

'--- Process DRAM values as Ascii text ---------
'This option is specifically to support a PS2 keyboard lab project.
'Each 16-bit Mem value is interpreteded as two ascii characters
MDat = ReadBuffer(K + 1)    'high byte is 1st char
'If Mdat = 8 Then     'backspace one char unless accum is empty
'    accum = Left(accum, Len(accum) - 1)
'End If
If MDat = 13 Then      'This allows for <cr>'s in the stored text
    accum = accum & vbCrLf
Else: accum = accum & Chr(MDat)
End If
MDat = ReadBuffer(K + 2)    'low byte is 2nd char
If MDat = 13 Then      'Check for a <cr>
    accum = accum & vbCrLf
Else: accum = accum & Chr(MDat)
End If
GoTo ILOOP
'----Process dram values as 16-bit hex numbers----
HEXNUMS:
MDat = ReadBuffer(K + 2) + ReadBuffer(K + 1) * 2 ^ 8  'combine bytes for 16-bit values
hvalue = "000" & Hex(MDat) & " " 'next 4 digit hex value, add leading zeros in case
accum = accum & Right(hvalue, 5)

LINE:   'write out current accumulated text line to file every 8 values.
If 7 = (IMem Mod 8) Then  '8 values/line, each St-machine cycle sends 8- or 16-bit value
    Print #1, accum     ' write it, and initialize accum for next line.
    accum = " " & Right("00000" & Hex(IMem + 1), 6) & "   "      'word count=addr
End If
'-------------------------------------------------
ILOOP:
K = (K + 2) Mod 8    'as we go, increment read-buffer pointer by byte pairs.
If IMem = Imax - 1 Then GoTo XIT1
frmMain.Progress.Text = Int((100 * IMem) / Imax) & "%" 'update progress number.
IMem = IMem + 1: GoTo NEXT_IMEM

XIT1:   'Stop read interrupts and close file
  'SetMode (0)            'reset back to mode 0 out of read dram mode=2
  TmrMemRd.Enabled = False
  frmMain.LabelLocs.Caption = "Mem Read Ended." & vbCrLf & CStr(IMem) & " Locations read."
  Print #1, accum    'Write last results and close the text file.
  Close #1
  Shell "notepad c:\MemVals.txt", vbNormalFocus 'open the output text file with notepad
  On Error GoTo 0             'Reset error handling
  Exit Sub     '****************************
ErrT:        'Trap to print err info, or alternatively, ignore user Cancel or Xit from Open Dialog
  SetMode (0)
  MsgBox "Error: " & Err.Number & ", " & Err.Description & ", " & Err.source
  Exit Sub     '****************************
End Sub     'exit load mem timer function
'=========================================================================



Public Sub WriteReport()    '(see Axelson, pg 391)
'Send a data packet to the FPGA out of the static SendBuffer,
'  using an interrupt transfer on EP1_OUT if available, else a ctl xfer on EP0.
'We presume the SendBuffer has been loaded before this call,
' and that SendBuffer(0)=0 is the report ID. (see pg 392)
Dim Count As Integer
Dim NumberOfBytesWritten As Long
Dim Sent As String
'***************************************************
'API WriteFile- Sends a report to the device.
'Returns: success or failure.
'Requires: 1. the handle returned by CreateFile
'   2. a pointer to the sendbuffer
'   3.output report byte length returned by HidP_GetCaps
'***************************************************
NumberOfBytesWritten = 0
result = WriteFile _
    (HIDHandle, _
    SendBuffer(0), UBound(SendBuffer) + 1, _
    NumberOfBytesWritten, _
    0)
If result = 0 Then  'oops. Something wrong.
    Call DisplayResultOfAPICall("WriteFile")
    'Call Comm_err
    Exit Sub
End If

End Sub '...exit WriteReport()
'==================================================================================

Private Sub WriteOnePacket()
'Sends bytes from Byte1 textBox to the FPGA in an 8-byte packet.
'Then displays the packet bytes in hex in the byte display

Dim Data As String, ByteValue As String
Dim Size As Long, Posit As Long
Dim Count As Long
'If the device hasn't been detected or has been disconnected on a
'previous attempt, stop with a comm_err.

If MyDeviceDetected = False Then
    Call Comm_err
    Exit Sub
End If
'----------------------
'First - Load static SendBuffer with data from the textbox.
SendBuffer(0) = 0   'The first byte is always the Report ID
'The next bytes are data from the text box
Data = LTrim(Byte1.Text) '& " "
If Len(Data) = 0 Then
    MsgBox "Fill in some hex bytes to send"
    Exit Sub
End If
Data = Data & " "   'add a space to the end so we quit gracefully
For Count = 1 To Capabilities.OutputReportByteLength - 1
If Len(Data) = 0 Then
    SendBuffer(Count) = 0   'Pad with 0's if we run out of bytes
Else
    Posit = InStr(Data, " ")    'find position of 1st space char
    If Posit > 2 Then Posit = 3
    SendBuffer(Count) = "&H" & Left(Data, Posit - 1)  'take chars before a space
    Data = Mid(Data, Posit): Data = LTrim(Data)   'drop chars and trim the leading spaces
End If
Next Count
'----------------------
'2nd - Write the SendBuffer to the device. See Axelson, pg 379
'WriteReport does an interrupt xfer when interrupt endpoint available, else ctl xfer.
'Call WriteReport   'an interrupt write requires EP1 configured
'SendReport does ctl xfer via HidD_SetOutputReport, which only works for XP and later.
Call SendReport
'-----------------------
'3rd - Display what was written in the big byte text boxes
Label5.Caption = "Hex Bytes Written: "
For Count = 1 To UBound(SendBuffer)
'Add a leading 0 to single digit values 0 - F.
    If Len(Hex$(SendBuffer(Count))) < 2 Then
        ByteValue = "0" & Hex$(SendBuffer(Count))
    Else
        ByteValue = Hex$(SendBuffer(Count))
    End If
    'Put the bytes sent in the big byte text boxes
    If Count < 9 Then Text(Count - 1).Text = ByteValue
Next Count
'------------------
'Scroll to the bottom of the debug list box.
DebugOut.ListIndex = DebugOut.ListCount - 1

End Sub     ' Exit WriteOnePacket()
'------------------------------------------------------
